//------------------------------------------------------------------
#property link      "www.forex-tsd.com"
#property copyright "www.forex-tsd.com"
//------------------------------------------------------------------

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1  Lime
#property indicator_color2  Red

//
//
//
//
//

extern int Fast.MA.Period        = 5;
extern int Fast.MA.method        = MODE_SMA;
extern int Fast.MA.applied_price = PRICE_CLOSE;
extern int Slow.MA.Period        = 35;
extern int Slow.MA.method        = MODE_SMA;
extern int Slow.MA.applied_price = PRICE_CLOSE;

extern string note               = "turn on Alert = true";
extern bool   alertsOn           = true;
extern bool   alertsOnCurrent    = true;
extern bool   alertsMessage      = true;
extern bool   alertsSound        = true;
extern bool   alertsEmail        = false;
extern string soundfile          = "alert2.wav";

extern string note7              = "Arrow Type";
extern string note8              = "0=default,1=Thick,2=Thin,3=Hollow";
extern string note9              = "4=Round,5=Fractal,6=Diagonal Thin";
extern string note10             = "7=Diagonal Thick,8=Diagonal Hollow";
extern string note11             = "9=Thumb,10=Finger";
extern int    ArrowType          = 2;
extern int    arrowthickness     = 2;

//
//
//
//
//

double FMABuf[];
double FCABuf[];
double SMABuf[];
double SCABuf[];
double CrossUp[];
double CrossDn[];
double trend[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{      
   IndicatorBuffers(7);
   if (ArrowType == 0) {
   SetIndexBuffer(0, CrossUp);  SetIndexStyle(0,DRAW_ARROW,0,arrowthickness); SetIndexArrow(0,119);
   SetIndexBuffer(1, CrossDn );  SetIndexStyle(1,DRAW_ARROW,0,arrowthickness); SetIndexArrow(1,119);
   }
   if (ArrowType == 1) {
   SetIndexBuffer(0, CrossUp);  SetIndexStyle(0, DRAW_ARROW,0,arrowthickness); SetIndexArrow(0, 233);
   SetIndexBuffer(1, CrossDn);  SetIndexStyle(1, DRAW_ARROW,0,arrowthickness); SetIndexArrow(1, 234);
   }
   else if (ArrowType == 2) { 
   SetIndexBuffer(0, CrossUp);  SetIndexStyle(0, DRAW_ARROW,0,arrowthickness); SetIndexArrow(0, 225);
   SetIndexBuffer(1, CrossDn);  SetIndexStyle(1, DRAW_ARROW,0,arrowthickness); SetIndexArrow(1, 226);
   }
   else if (ArrowType == 3) { 
   SetIndexBuffer(0, CrossUp);  SetIndexStyle(0, DRAW_ARROW,0,arrowthickness); SetIndexArrow(0, 241);
   SetIndexBuffer(1, CrossDn);  SetIndexStyle(1, DRAW_ARROW,0,arrowthickness); SetIndexArrow(1, 242);
   }
   else if (ArrowType == 4) { 
   SetIndexBuffer(0, CrossUp);  SetIndexStyle(0, DRAW_ARROW,0,arrowthickness); SetIndexArrow(0, 221);
   SetIndexBuffer(1, CrossDn);  SetIndexStyle(1, DRAW_ARROW,0,arrowthickness); SetIndexArrow(1, 222);
   }
   else if (ArrowType == 5) { 
   SetIndexBuffer(0, CrossUp);  SetIndexStyle(0, DRAW_ARROW,0,arrowthickness); SetIndexArrow(0, 217);
   SetIndexBuffer(1, CrossDn);  SetIndexStyle(1, DRAW_ARROW,0,arrowthickness); SetIndexArrow(1, 218);
   }
   else if (ArrowType == 6) { 
   SetIndexBuffer(0, CrossUp);  SetIndexStyle(0, DRAW_ARROW,0,arrowthickness); SetIndexArrow(0, 228);
   SetIndexBuffer(1, CrossDn);  SetIndexStyle(1, DRAW_ARROW,0,arrowthickness); SetIndexArrow(1, 230);
   }
   else if (ArrowType == 7) { 
   SetIndexBuffer(0, CrossUp);  SetIndexStyle(0, DRAW_ARROW,0,arrowthickness); SetIndexArrow(0, 236);
   SetIndexBuffer(1, CrossDn);  SetIndexStyle(1, DRAW_ARROW,0,arrowthickness); SetIndexArrow(1, 238);
   }
   else if (ArrowType == 8) { 
   SetIndexBuffer(0, CrossUp);  SetIndexStyle(0, DRAW_ARROW,0,arrowthickness); SetIndexArrow(0, 246);
   SetIndexBuffer(1, CrossDn);  SetIndexStyle(1, DRAW_ARROW,0,arrowthickness); SetIndexArrow(1, 248);
   }
   else if (ArrowType == 9) { 
   SetIndexBuffer(0, CrossUp);  SetIndexStyle(0, DRAW_ARROW,0,arrowthickness); SetIndexArrow(0, 67);
   SetIndexBuffer(1, CrossDn);  SetIndexStyle(1, DRAW_ARROW,0,arrowthickness); SetIndexArrow(1, 68);
   }
   else if (ArrowType == 10) { 
   SetIndexBuffer(0, CrossUp);  SetIndexStyle(0, DRAW_ARROW,0,arrowthickness); SetIndexArrow(0, 71);
   SetIndexBuffer(1, CrossDn);  SetIndexStyle(1, DRAW_ARROW,0,arrowthickness); SetIndexArrow(1, 72);
   }
   
   SetIndexBuffer(2, FCABuf);
   SetIndexBuffer(3, FMABuf);
   SetIndexBuffer(4, SCABuf);
   SetIndexBuffer(5, SMABuf);
   SetIndexBuffer(6, trend);
   return(0);
}

//
//
//
//
//

int deinit()
{
   return(0);
}

//
//
//
//
//

int start()
{
   int i,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
   
   //
   //
   //
   //
   //
   
   for (i=limit-1; i >= 0; i--)
   {
      FMABuf[i] = iMA(NULL,0,Fast.MA.Period,0,Fast.MA.method,Fast.MA.applied_price,i);
      SMABuf[i] = iMA(NULL,0,Slow.MA.Period,0,Slow.MA.method,Slow.MA.applied_price,i);
      
      //
      //
      //
      //
      //
      
      if (i == Bars-1)
      {
        FCABuf[i] = FMABuf[i];
        SCABuf[i] = SMABuf[i];
        continue;
      }
    
    //
    //
    //
    //
    //
    
    double v1 = MathPow(iStdDev(NULL,0,Fast.MA.Period,0,Fast.MA.method,Fast.MA.applied_price,i),2);
    double v2 = MathPow(FCABuf[i+1] - FMABuf[i], 2);
    double v3 = MathPow(iStdDev(NULL,0,Slow.MA.Period,0,Slow.MA.method,Slow.MA.applied_price,i),2);
    double v4 = MathPow(SCABuf[i+1] - SMABuf[i], 2);
    double f = 0;
    double s = 0;
    
    if (v2 < v1 || v2 == 0) f = 0; else f = 1 - v1/v2;
    if (v4 < v3 || v4 == 0) s = 0; else s = 1 - v3/v4;

    FCABuf[i] = FCABuf[i+1] + f *(FMABuf[i]-FCABuf[i+1]);
    SCABuf[i] = SCABuf[i+1] + s *(SMABuf[i]-SCABuf[i+1]);
    
    trend[i]  = trend[i+1];
       if (FCABuf[i]>SCABuf[i]) trend[i] = 1; 
       if (FCABuf[i]<SCABuf[i]) trend[i] =-1; 
       
       //
       //
       //
       //
       //
       
       CrossUp[i] = EMPTY_VALUE;
       CrossDn[i] = EMPTY_VALUE;
       if (trend[i] !=trend[i+1])
       if (trend[i] == 1)
             CrossUp[i] = Low[i] - iATR(NULL,0,20,i)/2.0;
       else  CrossDn[i] = High[i]+ iATR(NULL,0,20,i)/2.0;
       
       }
       
       //
       //
       //
       //
       //
         
       if (alertsOn)
       {
         if (alertsOnCurrent)
              int whichBar = 0;
         else     whichBar = 1;
         if (trend[whichBar] != trend[whichBar+1])
         if (trend[whichBar] == 1)
               doAlert("uptrend");
         else  doAlert("downtrend");       
   }
   
return(0);
}

//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," ma_i-CA cross ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," ma_i-CA cross "),message);
             if (alertsSound)   PlaySound(soundfile);
      }
}

       
       